<#macro login action isRegistration>
    <div class="container mt-5">
        <div class="row justify-content-center">
            <div class="col-md-4">
                <#if !isRegistration>
                    <h2 class="text-center">Log in to Sweater</h2>
                <#else>
                    <h2 class="text-center">Sign up to Sweater</h2>
                </#if>

                <form action="${action}" method="post">
                    <#if isRegistration>
                        <div class="form-group mb-3">
                            <label for="tg">Telegram username</label>
                            <input name="telegramUsername" id="tg" class="form-control" type="text" placeholder="telegram username" required />
                        </div>
                    </#if>
                    <div class="form-group mb-3">
                        <label for="username">Username</label>
                        <input name="username" class="form-control" id="username" type="text" required placeholder="Username" />
                    </div>
                    <div class="form-group mb-3">
                        <label for="password">Password</label>
                        <input name="password" id="password" class="form-control" type="password" placeholder="Password" required />
                    </div>

                    <input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}" />
                    <div class="form-group mb-3">
                        <button type="submit" class="btn btn-primary">
                            <#if isRegistration>
                                Sign up
                            <#else>
                                Log in
                            </#if>
                        </button>
                    </div>
                    <#if !isRegistration>
                        <div class="form-group text-center">
                            <a href="/registration">Sign up for Switter</a>
                        </div>
                    </#if>
                </form>
            </div>
        </div>
    </div>

</#macro>

<#macro logout>
    <form action="/logout" method="post">
        <input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}" />
        <button type="submit" class="btn btn-link">Logout</button>
    </form>
</#macro>
